package rocks.zipcode.quiz5.collections;

import java.util.HashMap;
import java.util.Map;

public class WordCounter {
    private Integer counter;

    private String[] strings;


    public WordCounter(String... strings) {
        this.strings = strings;
    }

    public Map<String, Integer> getWordCountMap() {
        Map <String, Integer> wordAndCount = new HashMap<>();
        Integer counter = 1;
        for (String s: strings) {
            if (wordAndCount.containsKey(s)) {
                wordAndCount.put(s, counter);
            } else {
                wordAndCount.put(s, counter++);
            }
        }
        return wordAndCount;
    }
}
