package rocks.zipcode.quiz5.fundamentals;

import java.util.Arrays;

/**
 * @author leon on 21/12/2018.
 */
public class StringUtils {
    public static Character getMiddleCharacter(String string) {
        int middleIndex = (string.length()) / 2;
        return string.charAt(middleIndex);
    }

    public static String capitalizeMiddleCharacter(String str) {
        int middleIndex = (str.length()) / 2;
        return str.substring(0, middleIndex) + getMiddleCharacter(str).toString().toUpperCase() + str.substring(middleIndex+1);
    }

    public static String lowerCaseMiddleCharacter(String str) {
        int middleIndex = (str.length()) / 2;
        return str.substring(0, middleIndex) + getMiddleCharacter(str).toString().toLowerCase() + str.substring(middleIndex+1);
    }

    public static Boolean isIsogram(String str) {    //aka a term for a word or phrase without a repeating letter.
        //str = str.toLowerCase();

        char arr[] = str.toCharArray();
        Arrays.sort(arr);

        for (int i = 0; i < str.length() - 1; i++) {
            if (arr[i] == arr[i + 1])
                return false;
        }                                       //technically works BUT test cases consider Jj to be true...
        return true;
    }

    public static Boolean hasDuplicateConsecutiveCharacters(String str) { //first test case is wrong
        for (int i = 0; i < str.length()-1; i++) {
            if (str.charAt(i) == str.charAt(i + 1)) {
                return true;
            }
        }
        return false;
    }

    public static String removeConsecutiveDuplicateCharacters(String str) {
        StringBuilder newStr = new StringBuilder();
        char[] strChar = str.toCharArray();
        for (int i = 0; i < strChar.length; i++) {
            if (!hasDuplicateConsecutiveCharacters(str)) {
                newStr.append(strChar[i]);
            }
        }
        return newStr.toString();
    }

    public static String invertCasing(String str) {
        char [] stringChars = str.toCharArray();
        for (int i = 0; i < stringChars.length; i++) {
            if (stringChars[i] != str.toUpperCase().indexOf(i)) {
                str.toLowerCase().indexOf(i);
            } else if ((stringChars[i] != str.toLowerCase().indexOf(i))) {
                str.toUpperCase().indexOf(i);
            }
        }
        return str;
    }
}