package rocks.zipcode.quiz5.objectorientation.account;

/**
 * @author leon on 27/12/2018.
 */
public class BankAccount extends Account implements Transactable {
    private Integer id;
    private Double val;

    public BankAccount() {

    }

    public void setBalance(Double val) {
        this.val = val;
    }
    public BankAccount(Integer id) {
        this.id = id;
    }

    public Integer getId() {
        return id;
    }

    public void setId(Integer id) {
        this.id = id;
    }

    @Override
    public void deposit(Double amountToIncreaseBy) throws IllegalArgumentException {
        if (amountToIncreaseBy < 0) {
            throw new IllegalArgumentException();
        } else {
            val += amountToIncreaseBy;
//        } catch (IllegalArgumentException e) {
//            throw new IllegalArgumentException();
//        }
        }
    }

    @Override
    public void withdrawal(Double amountToDecreaseBy) throws IllegalArgumentException {
        if (Math.abs(amountToDecreaseBy) >  val) {
            throw new IllegalArgumentException();
        } else
            val -= amountToDecreaseBy;
        }

    @Override
    public Double getBalance() {
        return this.val;
    }
}
